remove kinsis / unused input settings
[distro-setup] / btrbk-run
index c226997d1a147d2cb1b0f01f83d347ee4fd760c5..5ff83260022c20d1eeec2217ae8392b61653b69d 100755 (executable)
--- a/btrbk-run
+++ b/btrbk-run
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
+
+# todo: remove old leaf subvols, like keep up to 1 month or something.
+
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+
 usage() {
     echo "top of script file:"
     sed -n '1,/^[# ]*end command line/{p;b};q' "$0"
@@ -25,34 +29,129 @@ usage() {
 
 script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
 
-# todo: finish figuring out fai / distro-setup
-# initial fstab / subvol setup.
+# note q is owned by root:1000
+# note p/m is owned 1000:1000 and chmod 700
+
+
+mountpoints=()
+
+rsync_mountpoint=/q
 
 conf_only=false
 dry_run=false # mostly for testing
 resume_arg=
+rate_limit=no
+verbose=false
 
-temp=$(getopt -l help hcnrt: "$@") || usage 1
+default_args_file=/etc/btrbk-run.conf
+if [[ -s $default_args_file ]]; then
+    set -- $(< $default_args_file) "$@"
+fi
+
+temp=$(getopt -l help cl:m:nprt:vh "$@") || usage 1
 eval set -- "$temp"
 while true; do
     case $1 in
+        # only creates the config file, does not run btrbk
         -c) conf_only=true; shift ;;
+        -l) rate_limit=$2; shift 2 ;;
+        -m) IFS=, mountpoints=($2); unset IFS; shift 2 ;;
         -n) dry_run=true; dry_run_arg=-n; shift ;;
+        -p) progress_arg="--progress"; shift ;;
+        # btrbk arg: Resume only. Skips snapshot creation.
         -r) resume_arg=-r; shift ;;
-        -t) IFS=, targets=($2); shift 2 ;;
+        # empty is valid for just doing local snapshot. we have default hosts
+        # we will populate
+        -t) IFS=, targets=($2); unset IFS; shift 2 ;;
+        -v) verbose=true; verbose_arg=-v; shift ;;
         -h|--help) usage ;;
         --) shift; break ;;
         *) echo "$0: Internal error!" ; exit 1 ;;
     esac
 done
-read primary <<<"$@"
+
+if [[ -s $default_args_file ]]; then
+    echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
+    cat $default_args_file
+    sleep 5
+fi
+
+echo -e "$0: options: conf_only=$conf_only\ndry_run=$dry_run\nresume_arg=$resume_arg\nrate_limit=$rate_limit\nverbose=$verbose"
+
+# set default targets
+if [[ ! -v targets ]]; then
+    case $HOSTNAME in
+        x2|fz)
+            if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+                targets=($HOME_DOMAIN)
+            fi
+            ;;
+        tp)
+            targets=(frodo)
+            if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+                if timeout -s 9 10 ssh x2 :; then
+                    targets+=(x2)
+                fi
+            fi
+            ;;
+        frodo)
+            targets=()
+            ;;
+        *)
+            echo "$0: error: no default targets for this host, use -t"
+            exit 1
+            ;;
+    esac
+fi
+
+echo "targets: ${targets[*]}"
+
+
+
+if (( ${#mountpoints[@]} )); then
+    for mp in ${mountpoints[@]}; do
+        if [[ -e /nocow/btrfs-stale/$mp ]]; then
+            echo "$0: warning: $mp stale. Sleeping for 3 seconds in case you want to cancel."
+            sleep 3
+        fi
+    done
+else # set default mountpoints
+    case $HOSTNAME in
+        frodo)
+            prospective_mps=(/i)
+            ;;
+        *)
+            prospective_mps=(/a /q)
+            if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+                prospective_mps+=(/o)
+            fi
+            ;;
+    esac
+    case ${targets[0]} in
+        kw|kww)
+            prospective_mps=(/a)
+            ;;
+    esac
+
+    for mp in ${prospective_mps[@]}; do # default mountpoints to sync
+        if [[ -e /nocow/btrfs-stale/$mp ]]; then
+            echo "$0: warning: $mp stale, not adding to default mountpoints"
+            continue
+        fi
+        if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
+            mountpoints+=($mp)
+        fi
+    done
+fi
+
+echo "mountpoints: ${mountpoints[*]}"
 
 ##### end command line parsing ########
 
 rsync-dirs() {
     local host=$1
     local path=$2
-    rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
+    rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
 }
 
 vol-conf() {
@@ -70,15 +169,22 @@ tg-conf() {
 target send-receive ssh://$tg$vol/btrbk
 EOF
 }
-
+m() { printf "%s: %s\n" "${0##*/}" "$*";  "$@"; }
 
 
 if ! which btrbk &>/dev/null; then
     echo "$0: error: no btrbk binary found"
 fi
 
-cat >/etc/btrbk.conf <<'EOF'
-ssh_identity /root/.ssh/id_rsa
+cat >/etc/btrbk.conf <<EOF
+ssh_identity /root/.ssh/home
+# Just a guess that local7 is a good facility to pick.
+# It's a bit odd that the transaction log has to be logged to
+# a file or syslog, while other output is sent to std out.
+# The man does not mention a way for them to be together, but
+# I dunno if setting a log level like warn might also output
+# transaction info.
+transaction_syslog local7
 
 # so we only run one at a time
 lockfile                   /var/lock/btrbk.lock
@@ -88,85 +194,58 @@ timestamp_format long-iso
 
 # only make a snapshot if things have changed
 snapshot_create onchange
-# much less snapshots because I have less space on the
-# local filesystem.
-#snapshot_preserve 2h 2d
-# for now, keeping them equal for simplicity sake
-snapshot_preserve 48h 14d 8w 24m
-snapshot_preserve_min 6h
+# I could make this different from target_preserve,
+# if one disk had less space.
+# for now, keeping them equal.
+snapshot_preserve 36h 14d 8w 24m
+snapshot_preserve_min 4h
 snapshot_dir btrbk
 
 # so, total backups = ~89
-target_preserve 48h 14d 8w 24m
-target_preserve_min 6h
+target_preserve 36h 14d 8w 24m
+target_preserve_min 4h
 
 # if something fails and it's not obvious, try doing
 # btrbk -l debug -v dryrun
+
+rate_limit $rate_limit
 EOF
 
-# note q is owned by root:1000
-# note p is owned 1000:1000 and chmod 700
-mountpoints=(/q)
-if awk '{print $2}' /etc/fstab | grep -xF /p &>/dev/null; then
-    mountpoints+=(/p)
-fi
 
 # if our mountpoints are from stale snapshots,
 # it doesn't make sense to do a backup.
 check-subvol-stale ${mountpoints[@]} || exit 1
 
-if [[ ! $targets ]]; then
-    case $HOSTNAME in
-        tp|x2)
-            if ! timeout -s 9 10 ssh frodo :; then
-                targets=($HOME_DOMAIN)
-            fi
-            ;;
-    esac
-    targets=(frodo)
-fi
-
-
-# for i, we just do a 1 way sync from master to backup,
-# and manually manage any changes to that.
-do_i=false
 for tg in ${targets[@]}; do
     # for an initial run, btrbk requires the dir to exist
     ssh root@$tg mkdir -p /mnt/root/btrbk
-    if [[ $tg == frodo && $HOSTNAME == treetowl ]]; then
-        do_i=true
-    fi
 done
 
 
-vol=/mnt/root
-vol-conf
 for m in ${mountpoints[@]}; do
-    sub=${m##*/}
-    sub-conf
-    for tg in ${targets[@]}; do
+    # for /i, some special cases. there is just one static target and direction.
+    if [[ $m == /i ]]; then
+        vol=/mnt/iroot
+        vol-conf
+        sub=i
+        sub-conf
+        tg=frodo
+        vol=/mnt/root
         tg-conf
-    done
+    else
+        vol=/mnt/root
+        vol-conf
+        sub=${m##*/}
+        sub-conf
+        for tg in ${targets[@]}; do
+            tg-conf
+        done
+    fi
 done
 
-if $do_i; then
-    vol=/mnt/iroot
-    vol-conf
-    sub=i
-    sub-conf
-    tg=frodo
-    vol=/mnt/root
-    tg-conf
-fi
-
-
 
 # todo: umount first to ensure we don't have any errors
 # todo: do some kill fuser stuff to make umount more reliable
-# todo: run this on a systemd timer on $primary, once per hour,
-# and if primary is, change that timer over to primary, and make
-# sure we mount the latest
-
 
 
 if $conf_only; then
@@ -174,15 +253,15 @@ if $conf_only; then
 fi
 
 if $dry_run; then
-    btrbk -n $resume_arg run
+    m btrbk -v -n $resume_arg run
 else
     # -q and just using the syslog option seemed nice,
     # but it doesn't show when a send has a parent and when it doesn't.
-    btrbk $resume_arg run
+    m btrbk $verbose_arg $progress_arg $resume_arg run
 fi
 
-# if we have /p, rsync to targets without /p
-if mountpoint /p >/dev/null; then
+# if we have it, sync to systems which don't
+if mountpoint $rsync_mountpoint >/dev/null; then
     for tg in ${targets[@]}; do
         case $tg in
             tp|li|lk)
@@ -198,7 +277,7 @@ if mountpoint /p >/dev/null; then
 fi
 
 if ! $dry_run; then
-    $script_dir/mount-latest-remote ${targets[@]}
+    $script_dir/mount-latest-remote ${targets[@]}
 fi